; #########################################################################

      .386
      .model flat, stdcall
      option casemap :none   ; case sensitive

; #########################################################################

      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\kernel32.inc
      
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\kernel32.lib
      includelib Trainer.lib ; <- trenger den for  bruke Trainer.dll
      						 ; Trainer.dll inneholder en systemwide
      						 ; keyboardhook som jeg har laget.
      						 ; Den hooker keyboardet og sender en
      						 ; window message(WM_KEYBHOOK) til vinduet
      						 ; som blir spesifisert nr man caller
      						 ; InstallHook. Trainer-vinduet vrt m
      						 ; da behandle messagen. wParam inneholder
      						 ; da virtual-key coden til knappen som
      						 ; ble trykt.
      
; #########################################################################
       ;Prototyper           
       WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
       WinMain proto :DWORD
       SetLastIndex PROTO
       InstallHook PROTO :DWORD
	   UninstallHook PROTO

    ;Konstanter              
    .const
    IDC_STATUS equ 101  	  ; Dialog ID for Listboxen
    IDC_IMAGE equ 65535 	  ; Dialog ID for Static kontrollen som inneholder bildet
    WM_KEYBHOOK equ WM_USER+7 ;Verdi for WM_KEYBHOOK
    
    ;Initialiserte variabler           
    .data
        DlgName        db "TRAINERDLG",0
        ClassName      db "FHCF_Trainer",0
        wClass		   db "SWarClass",0
        msgInfo		   db "Enable trainer by pressing +",0dh,0ah,"Disable trainer by pressing -",0
        msgCaption	   db "Info",0
        statusInfo     db "Press * for more info",0
        statusHook     db "Hooking keyboardinput",0
        statusUnhook   db "Unhooking keyboardinput",0
        statusFind     db "Waiting for game...",0
        statusEnabled  db "Trainer Enabled",0
        statusDisabled db "Trainer Disabled",0
        statusFound    db "Game found, engaging trainer",0
        statusLost     db "Game lost, disengaging trainer",0
        errorProcess   db "Error opening process",0 
        TimerEnabled   db TRUE
        TrainFlag	   db FALSE
        ;32bit verdi(4 bytes)=10000 som skal skrives til minnet
        Buffer 		   dd 10000
    ;Uinitialiserte variabler                   
    .data?
        hInstance     dd ?
        hDlg		  dd ?
        hBmp		  dd ?
        hWindow		  dd ?
        Process_ID	  dd ?
        hProcess	  dd ?
                
    
    .code

start:

; #########################################################################

        invoke GetModuleHandle, NULL
        mov hInstance, eax
        invoke WinMain,hInstance
        
        invoke ExitProcess,eax

; #########################################################################
                 
WinMain proc hInst :DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG     
    	mov   wc.cbSize,SIZEOF WNDCLASSEX 
    	mov   wc.style, CS_HREDRAW or CS_VREDRAW 
    	mov   wc.lpfnWndProc, offset WndProc 
    	mov   wc.cbClsExtra,NULL 
    	mov   wc.cbWndExtra,DLGWINDOWEXTRA 
    	push  hInst 
    	pop   wc.hInstance 
    	mov   wc.hbrBackground,COLOR_BTNFACE+1 
    	mov   wc.lpszMenuName,0
    	mov   wc.lpszClassName,offset ClassName 
    	
    	invoke LoadIcon,hInst,500    ; icon ID
    	mov   wc.hIcon,eax 
    	mov   wc.hIconSm,eax 
    	invoke LoadCursor,NULL,IDC_ARROW 
    	mov   wc.hCursor,eax 
    	invoke RegisterClassEx, addr wc
    	
    	;Lager Dialog vinduet fra Dialog ressursen i rsrc.rc  
    	invoke CreateDialogParam,hInstance,ADDR DlgName,NULL,NULL,1 
    	mov   hDlg,eax 
    	invoke ShowWindow, hDlg,SW_SHOWNORMAL 
    	invoke UpdateWindow, hDlg
    	
    	;Loader bildet fra Bitmap ressursen i rsrc.rc
    	invoke LoadBitmap,hInstance,750
    	mov hBmp, eax
    	;Setter bildet inn i Static kontrollen    	     	 
    	invoke SendDlgItemMessage,hDlg,IDC_IMAGE,STM_SETIMAGE,IMAGE_BITMAP,hBmp 
    	;Putter oppstartsbeskjed inn i Listboxen
    	invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusInfo
    	invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusFind    	
    	;Starter timeren som leter etter StarCraft vinduet
    	invoke SetTimer,hDlg,1,1000,NULL
    	    	
    	    	
    	;Vanlig messageloop
    	.WHILE TRUE 
        	invoke GetMessage, ADDR msg,NULL,0,0 
        	.BREAK .IF (!eax) 
       		invoke IsDialogMessage, hDlg, ADDR msg 
        	.IF eax ==FALSE 
            	invoke TranslateMessage, ADDR msg 
            	invoke DispatchMessage, ADDR msg 
        	.ENDIF 
    	.ENDW 
    	mov     eax,msg.wParam 
    	ret 
    	
WinMain endp

WndProc proc hWnd :DWORD,uMsg :DWORD,wParam :DWORD,lParam :DWORD
    
        
		
    .if uMsg==WM_DESTROY
    	invoke PostQuitMessage,NULL
    	invoke DeleteObject,hBmp
    	.if TimerEnabled == TRUE
    		invoke KillTimer, hDlg, 1
    	.else
    		invoke UninstallHook 		 ;Unhooker keyboardet, ellers vil dllen fortsette
    						     		 ; sende WM_KEYBHOOK til et vindu som ikke eksisterer.
    		invoke CloseHandle, hProcess ;Husk alltid  lukke handle's til ting man pner
    	.endif
    	
    	    	
    .elseif uMsg == WM_CLOSE
    	invoke DestroyWindow,hWnd
         
    .elseif uMsg==WM_COMMAND
    
    .elseif uMsg == WM_KEYBHOOK ;Vinduet mottar denne beskjeden nr man trykker p en knapp
    							;hvor som helst i windows, forutsatt at keyboardhooken
    							;er installert med InstallHook-funksjonen fra Trainer.dll
    	 .if wParam == 107 ;Sjekker om knappen som ble trykt var +, isfall starter
    	 				   ;den Timer nr 2 som skriver til minnet hvert sekund.
         	.if TrainFlag == FALSE
         		mov TrainFlag, TRUE
         		invoke SetTimer,hDlg,2,1000,NULL
         		invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusEnabled
         		invoke SetLastIndex
         	.endif
         .endif           	
        
         .if wParam == 109 ;Sjekker om knappen som ble trykt var +, isfall stopper
         				   ;den Timer nr 2.
         	.if TrainFlag == TRUE
         		mov TrainFlag, FALSE
           		invoke KillTimer, hDlg, 2
           		invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusDisabled
           		invoke SetLastIndex
            .endif
         .endif             
    
        
    
    .elseif uMsg == WM_KEYUP
    	.if wParam == 106 ;Sjekker om knappen som ble trykt var *, isfall viser
    					  ;den en MessageBox med litt mer info. Dette er ikke 
    					  ;det samme som WM_KEYBHOOK, dette er ikke en systemwide
    					  ;sjekk. MessageBoxen skal bare komme frem hvis man trykker
    					  ;p * mens traineren har focus.
    		invoke MessageBox,hDlg,addr msgInfo, addr msgCaption, MB_OK or MB_ICONINFORMATION
    	.endif          
     
    .elseif uMsg == WM_TIMER ;Nr man starter en Timer med SetTimer APIen begynner windows
    						 ; sende en WM_TIMER message til vinduet som er spesifisert.
    						 ;Tidsintervallet mellom hver WM_TIMER message spesifiserer
    						 ;man ogs nr man caller SetTimer. Vinduet vrt fr her
    						 ;to WM_TIMER messages som skilles ved  sjekke om wParam
    						 ;er 1 eller 2. Koden for den frste timeren sjekker om
    						 ;StarCraft vinduet finnes, hvis det gjr det stoppes timeren
    						 ;med KillTimer, keyboardhooken blir installert, en handle
    						 ;til StarCraft prosessen blir hentet og Timer 2 blir startet.
    						 ;Timer 2 skriver til minnet hvert sekund.
    
    	.if wParam == 1 ;Timer 1
    		invoke FindWindow,addr wClass,0
    		.if eax != 0
    			mov hWindow, eax
    			invoke KillTimer, hDlg, 1
    			invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusFound
    			invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusHook
    			invoke SetLastIndex
    			invoke InstallHook, hDlg
    			mov TimerEnabled, FALSE
    			invoke GetWindowThreadProcessId,hWindow,addr Process_ID
    		    		
    			invoke OpenProcess,001f0000h,0,Process_ID
            	mov hProcess, eax
            	.if eax == 0
	            	invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr errorProcess            	            	
            		invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusUnhook             
            		invoke UninstallHook
            		invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusFound
            		invoke SetLastIndex
            		mov TimerEnabled, TRUE
            		invoke SetTimer,hDlg,1,1000,NULL
            	.else
            		invoke SetTimer, hDlg,2,1000,NULL
            		mov TrainFlag, TRUE
               	.endif
            .endif   		                                                                              		
    	.elseif wParam == 2 ;Timer 2
    		invoke FindWindow,addr wClass,0
    		.if eax != 0
    			invoke WriteProcessMemory,hProcess,4EFE0Ch,addr Buffer,4,0
    			invoke WriteProcessMemory,hProcess,4EFE3Ch,addr Buffer,4,0
    		.else ;Safety sjekk for at ikke traineren skal prve  skrive til minnet hvis
    			  ;StarCraft f.eks avsluttes. Den vil da resette alt til slik det var
    			  ;i begynnelsen.
    			invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusLost
    			invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusUnhook
    			invoke UninstallHook
    			invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_ADDSTRING,0,addr statusFind
    			invoke SetLastIndex
    			invoke KillTimer, hDlg, 2
    			invoke SetTimer,hDlg,1,1000,NULL
    			mov TimerEnabled, TRUE
    			mov TrainFlag, FALSE    			
    			
    		.endif
      	.endif
    	          
    .else 
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam 
        ret 
    .endif 
    xor    eax,eax 
    ret 

WndProc endp

;Denne funksjonen srger bare for at den siste listbox itemen i listboxen
;er synlig hver gang man legger til en ny listitem.
SetLastIndex proc
	invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_GETCOUNT,0,0
	dec eax
    invoke SendDlgItemMessage,hDlg,IDC_STATUS,LB_SETTOPINDEX,eax,0
ret
SetLastIndex endp


end start
